Attribute VB_Name = "RegAPI"
'dichiarazioni delle funzioni API necessarie
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpreserved As Long, lpType As Long, ByVal lpdata As Any, lpcbData As Long) As Long
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Declare Function RegSetValueExString Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpValue As String, ByVal cbData As Long) As Long
Declare Function RegSetValueExLong Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpValue As Long, ByVal cbData As Long) As Long
Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByVal lpSecurityAttributes As Long, phkResult As Long, lpdwDisposition As Long) As Long
'Api distruttrici
Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long

'Valori delle costanti che identificano le cartelle principali del registro
Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_PERFORMANCE_DATA = &H80000004
Public Const HKEY_CURRENT_CONFIG = &H80000005
Public Const HKEY_DYN_DATA = &H80000006

'Seguono le costanti utili per la scrittura e il salvataggio dei dati
Const KEY_QUERY_VALUE = &H1
Const KEY_CREATE_SUB_KEY = &H4
Const KEY_ENUMERATE_SUB_KEYS = &H8
Const KEY_NOTIFY = &H10
Const SYNCHRONIZE = &H100000
Const READ_CONTROL = &H20000
Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Const KEY_ALL_ACCESS = &H3F
Const REG_OPTION_NON_VOLATILE = 0
 
'costanti dei tipi di valori del registro
Public Const REG_SZ = 1 'stringa
Public Const REG_DWORD = 4 'valore Dword
Public Const REG_BINARY = 3 'valore binario

'tipi richiesti da alcune API
Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
End Type

'costante che indica il successo di una lettura
Const ERROR_SUCCESS = 0&


'**************************************************************************
' Le costanti da personalizzare
'**************************************************************************

'++++ il numero di files da tenere in memoria ( I deve essere uguale al numero
' di menu creati nella finestra principale)
Public Const I = 10

'++++ il percorso dove salvare la lista
'la cartella principale
Public Const MiaRootFolder = HKEY_LOCAL_MACHINE

'il percorso della sotto-cartella
Public Const MioPercorso = "Software\BGSoftware\Esempio MRUF"



'**************************************************************************
'Alcune funzioni di supporto
'**************************************************************************



Public Function GetRegValue(RootFolder As Long, Percorso As String, Dato As String, TipoDato As Long) As Variant
'cerca Dato nella sotto-cartella Percorso della cartella principale RootFolder
'RootFolder : rappresenta la cartella principale e pu assumere i valori delle seguenti costanti
'HKEY_CLASSES_ROOT
'HKEY_CURRENT_USER
'HKEY_LOCAL_MACHINE
'HKEY_USERS
'HKEY_CURRENT_CONFIG
'HKEY_DYN_DATA
'HKEY_PERFORMANCE_DATA
'Percorso : rappresenta il percorso del dato (cio la sottocartella)
'Dato : Indica il nome del dato
'TipoDato : Indica il tipo di dato e pu valere una delle seguenti costanti:
'REG_SZ stringa
'REG_DWORD valore Dword
'REG_BINARY  valore binario

'dichiaro delle costanti di supporto
Dim hKey As Long 'il numero della chiave
Dim ValoreDatoLong As Long
Dim ValoreDatoString As String
'il valore da restituire
Dim Lunghezza As Long

Dim tipo As Long

Dim risultato As Long

'Apriamo la chiave nel registro
risultato = RegOpenKeyEx(RootFolder, Percorso, 0, KEY_READ, hKey)

'risultato deve essere un valore valido e quindi lo controllo
If risultato <> ERROR_SUCCESS Then
'se risultato  sbagliato significa che c' stato un errore quindi richiudo tutto
'e restituisco una stringa vuota o 0
risultato = RegCloseKey(hKey)
If TipoDato = REG_SZ Then GetRegValue = "" Else GetRegValue = 0
Exit Function
End If


'Se va tutto bene allora leggo il valore. Da notare che in FolderName apparir
'il valore del dato richiesto, in lenFolderName apparir la lunghezza del dato
'e in tipo apparir il tipo di dato (Stringa, DWord o Binario)
If TipoDato = REG_SZ Then
    risultato = RegQueryValueEx(hKey, Dato, 0, tipo, ValoreDatoString, Lunghezza)
    ValoreDatoString = String(Lunghezza, 0) 'crea una stringa di caratteri NULL
    risultato = RegQueryValueEx(hKey, Dato, 0, tipo, ValoreDatoString, Lunghezza)
    If Right(ValoreDatoString, 1) = Chr(0) Then ValoreDatoString = Left(ValoreDatoString, Lunghezza - 1) 'devo togliere lo zero finale
    GetRegValue = ValoreDatoString
Else
    risultato = RegQueryValueEx(hKey, Dato, 0, tipo, ValoreDatoLong, Lunghezza)
    GetRegValue = ValoreDatoLong
End If

'chiudo la chiave del registro
risultato = RegCloseKey(hKey)

'la mia funzione quindi restituir...

End Function










Public Sub AddRegValue(RootFolder As Long, Percorso As String, Dato As String, ValoreDato As Variant, TipoDato As Long)
'Questa procedura aggiunge valori nel registro di Windows. Bisogna specificare:
'RootFolder : rappresenta la cartella principale e pu assumere i valori delle seguenti costanti
'HKEY_CLASSES_ROOT
'HKEY_CURRENT_USER
'HKEY_LOCAL_MACHINE
'HKEY_USERS
'HKEY_CURRENT_CONFIG
'HKEY_DYN_DATA
'HKEY_PERFORMANCE_DATA
'Percorso : rappresenta il percorso del dato (cio la sottocartella)
'Dato : Indica il nome del dato
'ValoreDato : Indica il valore da attribuire al Dato
'TipoDato : Indica il tipo di dato e pu valere una delle seguenti costanti:
'REG_SZ stringa
'REG_DWORD valore Dword
'REG_BINARY  valore binario

'Un possibile uso  il seguente AddRegValue HKEY_LOCAL_MACHINE, "Software\MiaCompagnia\MioProgramma\", "NomeUtente", "Mario Rossi", REG_SZ

Dim risultato As Long
Dim hKey As Long         'handle che identifica la chiave aperta

'apro la sottocartella specificata (la cartella deve esistere gia)
risultato = RegOpenKeyEx(RootFolder, Percorso, 0, KEY_ALL_ACCESS, hKey)

'imposta il valore del Dato a seconda del tipo di dato
 Select Case TipoDato
     Case REG_SZ 'se  una stringa
         ValoreDato = ValoreDato & Chr$(0) 'devo aggiungere un carattere 0 finale
         risultato = RegSetValueExString(hKey, Dato, 0&, TipoDato, ValoreDato, Len(ValoreDato))
     Case REG_DWORD 'se  un Dword
         SetValueEx = RegSetValueExLong(hKey, Dato, 0&, TipoDato, ValoreDato, 3)
     Case REG_BINARY 'se  un binario
         SetValueEx = RegSetValueExLong(hKey, Dato, 0&, TipoDato, ValoreDato, 4)
End Select

'alla fine chiudo la sottocartella
RegCloseKey (hKey)
End Sub






Public Sub NuovaChiave(RootFolder As Long, Percorso As String)
'Questa procedura crea la sotto-cartella Percorso nella cartella principale RootFolder
'RootFolder e Percorso hanno i consueti significati
'Un possibile uso  il seguente: NuovaChiave HKEY_LOCAL_MACHINE, "Software\MiaCompagnia\MioProgramma"

Dim hKey As Long      'handle che identifica la nuova chiave
Dim risultato As Long      'risultato della funzione RegCreateKeyEx
       
       
risultato = RegCreateKeyEx(RootFolder, Percorso, 0&, vbNullString, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 0&, hKey, risultato)

'ora chiudo la chiave (sotto-cartella)
RegCloseKey (hKey)
End Sub









Public Sub EliminaDato(RootFolder As Long, Percorso As String, Dato As String)
'Questa procedura crea la sotto-cartella Percorso nella cartella principale RootFolder
'RootFolder e Percorso hanno i consueti significati
'Un possibile uso  il seguente: NuovaChiave HKEY_LOCAL_MACHINE, "Software\MiaCompagnia\MioProgramma"

Dim hKey As Long      'handle che identifica la nuova chiave
Dim risultato As Long      'risultato della funzione RegCreateKeyEx
       
'apro la sotto-cartella cos ottengo l'handle (hKey)
risultato = RegOpenKeyEx(RootFolder, Percorso, 0, KEY_ALL_ACCESS, hKey)

RegDeleteValue hKey, Dato

'ora chiudo la chiave (sotto-cartella)
RegCloseKey (hKey)
End Sub







'**************************************************************************
'Queste funzioni gestiscono la lista dei Files Recenti
'(Most Recent Used Files = MRUF)
'Per utilizzare la gestione, chiamate create 10 menu (o meno o pi ma dovete cambiare
'la costante I all'inizio del modulo) con lo stesso nome (matrice) e con indici
'da 1 a 10 (I). Ogni volta che la vostra applicazione apre o salva un file, chiamate
'la funzione GestioneMRUF inserendo come parametro il percorso
'del file da controllare.
'Per caricare il file, quando l'utente clicca sulla voce di menu corrispondente,
'chiamate la funzione GetMRUF con argomento il numero dell'elemento del menu
'che  stato cliccato e poi utilizzate il risultato come percorso del file.
'All'avvio del programma chiamare GestioneMRUF con PercorsoFile=""
'**************************************************************************

Public Sub AddMRUF(PercorsoFile As String)
'Questa procedura verifica se il file PercorsoFile  gi nella lista
'Restituisce true se il file  stato salvato. Se restituisce false significa che
'il file era gi presente nella lista

Dim tempPath As Variant
Dim m As Integer
Dim t As Integer

'creo la chiave nel caso sia la prima volta
NuovaChiave MiaRootFolder, MioPercorso

'cerco il percorso
For m = 1 To I
    tempPath = GetMRUF(m)
    If tempPath = PercorsoFile Then Exit For 'se lo trovo mi ricordo che era in posizione m
    If tempPath = "" Then GoTo ok 'se la lista  finita esco ugualmente
Next m

'a meno che non sia gi nella posizione 1 sposto tutti pi in basso
If m = 1 Then Exit Sub

ok:

'se non l'ho trovato sposto tutti i percorsi in basso...
For t = m - 1 To 1 Step -1
    AddRegValue MiaRootFolder, MioPercorso, "File" & CStr(t + 1), GetMRUF(t), REG_SZ
Next t

'... e salvo il percorso nella prima posizione
AddRegValue MiaRootFolder, MioPercorso, "File" & CStr(1), PercorsoFile, REG_SZ

End Sub

Public Function GetMRUF(NumeroFile As Integer) As String
'Restituisce il percorso del file numero NumeroFile salvato nel registro
'Restituisce una stringa vuota se non trova nulla

GetMRUF = GetRegValue(MiaRootFolder, MioPercorso, "File" & CStr(NumeroFile), REG_SZ)
End Function
