Attribute VB_Name = "WinRegistry"
'**************************************************************************
'NomeFile : WinRegistry.bas Modificato Per MostRecentUsedFiles
'Descrizione: Modulo Bas per utilizzare il registro di Windows
'Autore: Giorgio Bernardi
'E-Mail: BGSoftware@hotmail.com
'Data:   Novembre 2000
'Info:   Potete usare liberamente questo file aggiungendolo ai vostri progetti
'**************************************************************************

'dichiarazioni delle funzioni API necessarie
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryInfoKey Lib "advapi32.dll" Alias "RegQueryInfoKeyA" (ByVal hKey As Long, ByVal lpClass As String, lpcbClass As Long, lpReserved As Long, lpcSubKeys As Long, lpcbMaxSubKeyLen As Long, lpcbMaxClassLen As Long, lpcValues As Long, lpcbMaxValueNameLen As Long, lpcbMaxValueLen As Long, lpcbSecurityDescriptor As Long, lpftLastWriteTime As FILETIME) As Long
Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwindex As Long, ByVal lpName As String, lpcbName As Long, lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As FILETIME) As Long
Private Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwindex As Long, ByVal lpName As String, ByVal cbName As Long) As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwindex As Long, ByVal lpValueName As String, lpcbValueName As Long, lpReserved As Long, lpType As Long, lpData As Byte, lpcbData As Long) As Long
Private Declare Function RegFlushKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As Any, lpcbData As Long) As Long
Private Declare Function RegQueryValueExLong Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Long, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegLoadKey Lib "advapi32.dll" Alias "RegLoadKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpFile As String) As Long
Private Declare Function RegUnLoadKey Lib "advapi32.dll" Alias "RegUnLoadKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegSaveKey Lib "advapi32.dll" Alias "RegSaveKeyA" (ByVal hKey As Long, ByVal lpFile As String, lpSecurityAttributes As SECURITY_ATTRIBUTES) As Long
Private Declare Function RegSetValueExString Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpValue As String, ByVal cbData As Long) As Long
Private Declare Function RegSetValueExLong Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpValue As Long, ByVal cbData As Long) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByVal lpSecurityAttributes As Long, phkResult As Long, lpdwDisposition As Long) As Long
'Api distruttrici
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long

'dichiarazioni per ottenere la cartella di sistema e la cartella di Windows
Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function GetWindowsDirectory& Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long)
Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

'Valori delle costanti che identificano le cartelle principali del registro
Private Const HKEY_CLASSES_ROOT = &H80000000
Private Const HKEY_CURRENT_USER = &H80000001
Private Const HKEY_LOCAL_MACHINE = &H80000002
Private Const HKEY_USERS = &H80000003
Private Const HKEY_PERFORMANCE_DATA = &H80000004
Private Const HKEY_CURRENT_CONFIG = &H80000005
Private Const HKEY_DYN_DATA = &H80000006


'**************************************************************************
' Le costanti da personalizzare
'**************************************************************************

'++++ il numero di files da tenere in memoria ( I deve essere uguale al numero
' di menu creati nella finestra principale)
Public Const I = 10

'++++ il percorso dove salvare la lista
'la cartella principale
Public Const MiaRootFolder = HKEY_LOCAL_MACHINE

'il percorso della sotto-cartella
Public Const MioPercorso = "Software\BGSoftware\Esempio MRUF"




'Valori di Comodo associati alle cartelle principali per la funzione
'GetImportantFolderByVal
Public Enum ShellFoldersSh
    AppData_ShFolder
    Cache_ShFolder
    Cookies_ShFolder
    Desktop_ShFolder
    Preferiti_ShFolder
    Fonts_ShFolder
    History_ShFolder
    NetHood_ShFolder
    Personali_ShFolder
    Stampanti_ShFolder
    Programmi_ShFolder
    Recenti_ShFolder
    InviaA_ShFolder
    MenuAvvio_ShFolder
    EsecuzioneAutomatica_ShFolder
    Templates_ShFolder
End Enum

'Definiamo queste costanti che identificano alcune sottocartelle utili per
'alcune informazioni del sistema

'Il seguente percorso contiene le informazioni di disinstallazione per i programmi
'installati nel computer nella cartella principale HKEY_LOCAL_MACHINE
'ogni programma ha una cartella contentente due valori di tipo stringa:
'DisplayName = Stringa da visualizzare nella finestra Installazione Applicazioni di Windos
'UninstallString = Comando da chiamare per disinstallare
Const Uninstall = "Software\Microsoft\Windows\CurrentVersion\Uninstall"

'Il seguente percorso contiene i percorsi delle seguenti cartelle
'principali (il percorso  nella cartella HKEY_CURRENT_USER)
'AppData
'Cache (cache di internet Explorer per Internet)
'Cookies
'Desktop
'Favorites (il percorso del menu Preferiti)
'Fonts
'History
'NetHood
'Personal (la cartella Documenti)
'PrintHood
'Programs (la cartella dei programmi nel menu di Avvio)
'Recent (I Files recenti: vengono salvati i collegamenti ai files)
'SendTo (La cartella Invia a: vengono salvati i collegamenti a cartelle ecc...)
'Start Menu (il menu di avvio)
'StartUp (Il menu Esecuzione Automatica dove vengono salvati i collegamenti ai programmi
        'che saranno fatti partire automaticamente all'avvio di windows
'Templates
Const ShellFolders = "Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders"

'Seguono le costanti utili per la scrittura e il salvataggio dei dati
Const KEY_QUERY_VALUE = &H1
Const KEY_CREATE_SUB_KEY = &H4
Const KEY_ENUMERATE_SUB_KEYS = &H8
Const KEY_NOTIFY = &H10
Const SYNCHRONIZE = &H100000
Const READ_CONTROL = &H20000
Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Const KEY_ALL_ACCESS = &H3F
Const REG_OPTION_NON_VOLATILE = 0
 
'costanti dei tipi di valori del registro
Public Const REG_SZ = 1 'stringa
Public Const REG_DWORD = 4 'valore Dword
Public Const REG_BINARY = 3 'valore binario

'tipi richiesti da alcune API
Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
End Type

'costante che indica il successo di una lettura
Const ERROR_SUCCESS = 0&

'**************************************************************************
'E ora ecco le funzioni che potete chiamare nella vostra applicazione
'**************************************************************************
'   Elenco:
'   Public Function GetRegValue(RootFolder As Long, percorso As String, Dato As String, TipoDato As Long) As Variant
'   Public Function GetImportantFolder(NomeFolder As String) As String
'   Public Function GetImportantFolderByVal(NomeFolder As ShellFoldersSh) As String
'   Public Function GetRegValueMiaCartella(Dato As String, TipoDato As Long) As Variant
'   Public Sub AddRegValue(RootFolder As Long, ByVal percorso As String, ByVal Dato As String, ByVal ValoreDato As Variant, TipoDato As Long)
'   Public Sub AddRegValueMiaCartella(Dato As String, ValoreDato As Variant, TipoDato As Long)
'   Public Sub NuovaChiave(RootFolder As Long, ByVal percorso As String)
'   Public Sub EliminaChiave(RootFolder As Long, percorso As String)
'   Public Sub EliminaDato(RootFolder As Long, percorso As String, Dato As String)
'   Public Sub InserisciUninstallInfo(nomeProgramma As String, versione As String, UnInstallString As String)
'   Public Function GetWinDir() As String
'   Public Function GetSysDir() As String
'   Public Function GetTempDir() As String
'   Public Sub AddMRUF(PercorsoFile As String)
'   Public Function GetMRUF(numeroFile As Integer) As String
'   Public Sub GestioneMRUF(Optional PercorsoFile As String = "")

Public Function GetRegValue(RootFolder As Long, percorso As String, Dato As String, TipoDato As Long) As Variant
'cerca Dato nella sotto-cartella Percorso della cartella principale RootFolder
'RootFolder : rappresenta la cartella principale e pu assumere i valori delle seguenti costanti
'HKEY_CLASSES_ROOT
'HKEY_CURRENT_USER
'HKEY_LOCAL_MACHINE
'HKEY_USERS
'HKEY_CURRENT_CONFIG
'HKEY_DYN_DATA
'HKEY_PERFORMANCE_DATA
'Percorso : rappresenta il percorso del dato (cio la sottocartella)
'Dato : Indica il nome del dato
'TipoDato : Indica il tipo di dato e pu valere una delle seguenti costanti:
'REG_SZ stringa
'REG_DWORD valore Dword
'REG_BINARY  valore binario

'dichiaro delle costanti di supporto
Dim hKey As Long 'il numero della chiave
Dim ValoreDatoLong As Long
Dim ValoreDatoString As String
'il valore da restituire
Dim Lunghezza As Long

Dim Tipo As Long

Dim risultato As Long

'Apriamo la chiave nel registro
risultato = RegOpenKeyEx(RootFolder, percorso, 0, KEY_READ, hKey)

'risultato deve essere un valore valido e quindi lo controllo
If risultato <> ERROR_SUCCESS Then
'se risultato  sbagliato significa che c' stato un errore quindi richiudo tutto
'e restituisco una stringa vuota o 0
risultato = RegCloseKey(hKey)
If TipoDato = REG_SZ Then GetRegValue = "" Else GetRegValue = 0
Exit Function
End If


'Se va tutto bene allora leggo il valore. Da notare che in FolderName apparir
'il valore del dato richiesto, in lenFolderName apparir la lunghezza del dato
'e in tipo apparir il tipo di dato (Stringa, DWord o Binario)
If TipoDato = REG_SZ Then
    risultato = RegQueryValueEx(hKey, Dato, 0, Tipo, ValoreDatoString, Lunghezza)
    ValoreDatoString = String(Lunghezza, 0) 'crea una stringa di caratteri NULL
    risultato = RegQueryValueEx(hKey, Dato, 0, Tipo, ValoreDatoString, Lunghezza)
    If Right(ValoreDatoString, 1) = Chr(0) Then ValoreDatoString = Left(ValoreDatoString, Lunghezza - 1) 'devo togliere lo zero finale
    GetRegValue = ValoreDatoString
Else
    risultato = RegQueryValueExLong(hKey, Dato, 0&, TipoDato, ValoreDatoLong, TipoDato)
    GetRegValue = ValoreDatoLong
End If

'chiudo la chiave del registro
risultato = RegCloseKey(hKey)

'la mia funzione quindi restituir...

End Function

Public Function GetImportantFolder(NomeFolder As String) As String
'restituisce il percorso della cartella NomeFolder
'NomeFolder pu avere uno dei seguenti valori:
'AppData
'Cache
'Cookies
'Desktop
'Favorites
'Fonts
'History
'NetHood
'Personal
'PrintHood
'Programs
'Recent
'SendTo
'Start Menu
'StartUp
'Templates

'dichiaro delle costanti di supporto
Dim hKey As Long 'il numero della chiave
Dim FolderName As String 'il valore da restituire
Dim lenFolderName As Long

Dim Tipo As Long

Dim risultato As Long

'Apriamo la chiave nel registro
risultato = RegOpenKeyEx(HKEY_CURRENT_USER, ShellFolders, 0, KEY_READ, hKey)

'risultato deve essere un valore valido e quindi lo controllo
If risultato <> ERROR_SUCCESS Then
'se risultato  sbagliato significa che c' stato un errore quindi richiudo tutto
'e restituisco una stringa vuota
risultato = RegCloseKey(hKey)
GetImportantFolder = ""
Exit Function
End If


'Se va tutto bene allora leggo il valore. Da notare che in FolderName apparir
'il valore del dato richiesto, in lenFolderName apparir la lunghezza del dato
'e in tipo apparir il tipo di dato (Stringa, DWord o Binario)
risultato = RegQueryValueEx(hKey, NomeFolder, 0, Tipo, FolderName, lenFolderName)

'Se il risultato  una stringa (e lo deve essere nel nostro caso) allora devo
'eseguire le seguenti operazioni
If Tipo = REG_SZ Then
    FolderName = String(lenFolderName, 0) 'crea una stringa di caratteri NULL
    risultato = RegQueryValueEx(hKey, NomeFolder, 0, Tipo, FolderName, lenFolderName)
    If Right(FolderName, 1) = Chr(0) Then FolderName = Left(FolderName, lenFolderName - 1) 'devo togliere lo zero finale
End If

'chiudo la chiave del registro
risultato = RegCloseKey(hKey)

'la mia funzione quindi restituir...
GetImportantFolder = FolderName

End Function

Public Function GetImportantFolderByVal(NomeFolder As ShellFoldersSh) As String
Dim Nome As String
Select Case NomeFolder
    Case AppData_ShFolder
        Nome = "AppData"
    Case Cache_ShFolder
        Nome = "Cache"
    Case Cookies_ShFolder
        Nome = "Cookies"
    Case Desktop_ShFolder
        Nome = "Desktop"
    Case Preferiti_ShFolder
        Nome = "Favorites"
    Case Fonts_ShFolder
        Nome = "Fonts"
    Case History_ShFolder
        Nome = "History"
    Case NetHood_ShFolder
        Nome = "NetHood"
    Case Personali_ShFolder
        Nome = "Personal"
    Case Stampanti_ShFolder
        Nome = "PrintHood"
    Case Programmi_ShFolder
        Nome = "Programs"
    Case Recenti_ShFolder
        Nome = "Recent"
    Case InviaA_ShFolder
        Nome = "SendTo"
    Case MenuAvvio_ShFolder
        Nome = "Start Menu"
    Case EsecuzioneAutomatica_ShFolder
        Nome = "StartUp"
    Case Templates_ShFolder
        Nome = "Templates"
End Select
'Chiamo la funzione principale qui sotto
GetImportantFolderByVal = GetImportantFolder(Nome)
End Function

Public Function GetRegValueMiaCartella(Dato As String, TipoDato As Long) As Variant
'Questa procedura restituisce valori nel registro di Windows in una cartella speciale
'Dovete indicare la cartella in questa costante:

Const RootFolder = HKEY_CURRENT_USER

'RootFolder : rappresenta la cartella principale e pu assumere i valori delle seguenti costanti
'HKEY_CLASSES_ROOT
'HKEY_CURRENT_USER
'HKEY_LOCAL_MACHINE
'HKEY_USERS
'HKEY_CURRENT_CONFIG
'HKEY_DYN_DATA
'HKEY_PERFORMANCE_DATA
'Inoltre dovete impostare il percorso della cartella e inserirlo qui sotto. Per esempio

Const percorso = "Software\MiaSocieta\MioSoftware"

'Ora uso la normale funzione per restituire il valore richiesto
GetRegValueMiaCartella = GetRegValue(RootFolder, percorso, Dato, TipoDato)

End Function


Public Sub AddRegValue(RootFolder As Long, ByVal percorso As String, ByVal Dato As String, ByVal ValoreDato As Variant, TipoDato As Long)
'Questa procedura aggiunge valori nel registro di Windows. Bisogna specificare:
'RootFolder : rappresenta la cartella principale e pu assumere i valori delle seguenti costanti
'HKEY_CLASSES_ROOT
'HKEY_CURRENT_USER
'HKEY_LOCAL_MACHINE
'HKEY_USERS
'HKEY_CURRENT_CONFIG
'HKEY_DYN_DATA
'HKEY_PERFORMANCE_DATA
'Percorso : rappresenta il percorso del dato (cio la sottocartella)
'Dato : Indica il nome del dato
'ValoreDato : Indica il valore da attribuire al Dato
'TipoDato : Indica il tipo di dato e pu valere una delle seguenti costanti:
'REG_SZ stringa
'REG_DWORD valore Dword
'REG_BINARY  valore binario

'Un possibile uso  il seguente AddRegValue HKEY_LOCAL_MACHINE, "Software\MiaCompagnia\MioProgramma\", "NomeUtente", "Mario Rossi", REG_SZ

Dim risultato As Long
Dim hKey As Long         'handle che identifica la chiave aperta

'apro la sottocartella specificata (la cartella deve esistere gia)
risultato = RegOpenKeyEx(RootFolder, percorso, 0, KEY_ALL_ACCESS, hKey)

'imposta il valore del Dato a seconda del tipo di dato
 Select Case TipoDato
     Case REG_SZ 'se  una stringa
         ValoreDato = ValoreDato & Chr$(0) 'devo aggiungere un carattere 0 finale
         risultato = RegSetValueExString(hKey, Dato, 0&, TipoDato, ValoreDato, Len(ValoreDato))
     Case REG_DWORD 'se  un Dword
         SetValueEx = RegSetValueExLong(hKey, Dato, 0&, TipoDato, CLng(ValoreDato), REG_DWORD)
     Case REG_BINARY 'se  un binario
         SetValueEx = RegSetValueExLong(hKey, Dato, 0&, TipoDato, CLng(ValoreDato), REG_BINARY)
End Select

'alla fine chiudo la sottocartella
RegCloseKey (hKey)
End Sub


Public Sub AddRegValueMiaCartella(Dato As String, ValoreDato As Variant, TipoDato As Long)
'Questa procedura aggiunge valori nel registro di Windows in una cartella speciale
'Dovete indicare la cartella in questa costante:

Const RootFolder = HKEY_CURRENT_USER

'RootFolder : rappresenta la cartella principale e pu assumere i valori delle seguenti costanti
'HKEY_CLASSES_ROOT
'HKEY_CURRENT_USER
'HKEY_LOCAL_MACHINE
'HKEY_USERS
'HKEY_CURRENT_CONFIG
'HKEY_DYN_DATA
'HKEY_PERFORMANCE_DATA
'Inoltre dovete impostare il percorso della cartella e inserirlo qui sotto. Per esempio

Const percorso = "Software\MiaSocieta\MioSoftware"

'Ora uso la normale funzione
Call AddRegValue(RootFolder, percorso, Dato, ValoreDato, TipoDato)

End Sub

Public Sub NuovaChiave(RootFolder As Long, ByVal percorso As String)
'Questa procedura crea la sotto-cartella Percorso nella cartella principale RootFolder
'RootFolder e Percorso hanno i consueti significati
'Un possibile uso  il seguente: NuovaChiave HKEY_LOCAL_MACHINE, "Software\MiaCompagnia\MioProgramma"

Dim hKey As Long      'handle che identifica la nuova chiave
Dim risultato As Long      'risultato della funzione RegCreateKeyEx
       
If Right(percorso, 1) = "\" Then percorso = Left(percorso, Len(percorso) - 1)

risultato = RegCreateKeyEx(RootFolder, percorso, 0&, vbNullString, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 0&, hKey, risultato)

'ora chiudo la chiave (sotto-cartella)
RegCloseKey (hKey)
End Sub

Public Sub EliminaChiave(RootFolder As Long, percorso As String)
'Questa procedura ELIMINA la sotto-cartella Percorso nella cartella principale RootFolder
'ATTENZIONE; LA FUNZIONE ELIMINA LA CARTELLA ANCHE SE NON VUOTA!
'RootFolder e Percorso hanno i consueti significati
'Un possibile uso  il seguente: EliminaChiave HKEY_LOCAL_MACHINE, "Software\MiaCompagnia\MioProgramma"
       
RegDeleteKey RootFolder, percorso

End Sub

Public Sub EliminaDato(RootFolder As Long, percorso As String, Dato As String)
'Questa procedura crea la sotto-cartella Percorso nella cartella principale RootFolder
'RootFolder e Percorso hanno i consueti significati
'Un possibile uso  il seguente: NuovaChiave HKEY_LOCAL_MACHINE, "Software\MiaCompagnia\MioProgramma"

Dim hKey As Long      'handle che identifica la nuova chiave
Dim risultato As Long      'risultato della funzione RegCreateKeyEx
       
'apro la sotto-cartella cos ottengo l'handle (hKey)
risultato = RegOpenKeyEx(RootFolder, percorso, 0, KEY_ALL_ACCESS, hKey)

RegDeleteValue hKey, Dato

'ora chiudo la chiave (sotto-cartella)
RegCloseKey (hKey)
End Sub

Public Sub InserisciUninstallInfo(nomeProgramma As String, versione As String, UnInstallString As String)
'Questa procedura crea le informazioni nel registro per disinstallare la vostra applicazione
'NomeProgramma  il nome del vostro programma
'Versione rappresenta la versione del vostro programma
'UnInstallString rappresenta il comando da lanciare per disinstallare il programma.
'Per esempio potrebbe essere qualcosa del tipo "C:\MiaCartella\Uninstall.exe C:\MiaCartella\uninstall.info"
'se il programma di disinstallazione si trova in quella cartella e si aspetta di ricevere
'in ingresso il percorso del file in cui sono memorizzate le informazioni necessarie a
'disinstallare il tutto. Oppure altro: dipende dal vostro programma di disinstallazione

'creo la chiave
NuovaChiave HKEY_LOCAL_MACHINE, Uninstall & "\" & nomeProgramma

'creo la scritta che sar visibile
AddRegValue HKEY_LOCAL_MACHINE, Uninstall & "\" & nomeProgramma, "DisplayName", nomeProgramma & " " & versione, REG_SZ

'creo la stringa per l'UnInstall
AddRegValue HKEY_LOCAL_MACHINE, Uninstall & "\" & nomeProgramma, "UninstallString", UnInstallString, REG_SZ
End Sub

Public Function GetWinDir() As String
'Restituisce il percorso della cartella di Windows tipo c:\Windows\

Dim WinDir As String
WinDir = Space$(260)
resultCode = GetWindowsDirectory(WinDir, 259)

'Il valore da restituire
GetWinDir = Left$(WinDir, resultCode) & "\"
End Function

Public Function GetSysDir() As String
'Restituisce il percorso della cartella di Sistema tipo c:\Windows\system\

Dim SysDir As String
SysDir = Space$(260)
resultCode = GetSystemDirectory(SysDir, 259)

'Il valore da restituire
GetSysDir = Left$(SysDir, resultCode) & "\"
End Function

Public Function GetTempDir() As String
'Restituisce il percorso della cartella temporanea di Windows tipo c:\Windows\temp\

Dim TempDir As String
Dim resultCode As Long
TempDir = Space$(260)
resultCode = GetTempPath(259, TempDir)

'Il valore da restituire
GetTempDir = Left$(TempDir, resultCode)
If Right(GetTempDir, 1) <> "\" Then GetTempDir = GetTempDir & "\"
End Function

'**************************************************************************
'Queste funzioni gestiscono la lista dei Files Recenti
'(Most Recent Used Files = MRUF)
'Per utilizzare la gestione, chiamate create 10 menu (o meno o pi ma dovete cambiare
'la costante I nelle funzioni che seguno) con lo stesso nome (matrice) e con indici
'da 1 a 10 (I). Ogni volta che la vostra applicazione apre o salva un file, chiamate
'la funzione GestioneMRUF inserendo come parametro il percorso
'del file da controllare.
'Per caricare il file, quando l'utente clicca sulla voce di menu corrispondente,
'chiamate la funzione GetMRUF con argomento il numero dell'elemento del menu
'che  stato cliccato e poi utilizzate il risultato come percorso del file.
'All'avvio del programma chiamare GestioneMRUF con PercorsoFile=""
'**************************************************************************


Public Sub AddMRUF(PercorsoFile As String)
'Questa procedura salva il percorso del file PercorsoFile in testa
'alla lista
Dim tempPath As Variant
Dim m As Integer
Dim t As Integer

'creo la chiave nel caso sia la prima volta
NuovaChiave MiaRootFolder, MioPercorso

'cerco il percorso
For m = 1 To I
    tempPath = GetMRUF(m)
    If tempPath = PercorsoFile Then Exit For 'se lo trovo mi ricordo che era in posizione m
    If tempPath = "" Then GoTo ok 'se la lista  finita esco ugualmente
Next m

'a meno che non sia gi nella posizione 1 sposto tutti pi in basso
If m = 1 Then Exit Sub

ok:

For t = m - 1 To 1 Step -1
    AddRegValue MiaRootFolder, MioPercorso, "File" & CStr(t + 1), GetMRUF(t), REG_SZ
Next t

'... e salvo il percorso nella prima posizione
AddRegValue MiaRootFolder, MioPercorso, "File" & CStr(1), PercorsoFile, REG_SZ

End Sub

Public Function GetMRUF(numeroFile As Integer) As String
'Restituisce il percorso del file numero NumeroFile salvato nel registro
'Restituisce una stringa vuota se non trova nulla

GetMRUF = GetRegValue(MiaRootFolder, MioPercorso, "File" & CStr(numeroFile), REG_SZ)
End Function

Public Sub GestioneMRUF(Optional PercorsoFile As String = "")
'Questa procedura gestisce totalmente il problema dei MRUF.
'PercorsoFile deve essere il percorso del file che viene memorizzato

'----------- CAMBIARE IL NOME DEL MENU SE NECESSARIO -----------
'------Per ipotesi I menu si trovano in F_Principale.Coll(Index)

Const L = 28 'imposta la lunghezza massima del percorso del file da visualizzare nel menu
Dim m As Integer

With F_MRuf


If PercorsoFile = "" Then GoTo leggi

AddMRUF (PercorsoFile)

leggi:
For m = 1 To I
    temp = GetMRUF(m)
    If Len(temp) > L Then temp = Right(temp, L)
    If temp = "" Then
        .M_MenuMRUF(m).Visible = False
    Else
        .M_MenuMRUF(m).Visible = True
        .M_MenuMRUF(m).Caption = temp
    End If
Next m
End With
End Sub
'********************** FINE MRUF ************
